/** 
 * DIV class="card-content" has possible options based on the following conditions, 
 *  1. No content - no children
 *  2. Just text - children will be just DIV class="card-text"
 *  2. Content is just an image - no DIV class="card-text, only child will be the <img> should be resized to use width="207" height="240"
 *  3. content will mixed content - children will have DIV class="card-text" if found text or p tags, plus others
 * 
 * Use [-COL-#] when there is information in the row_info_arrays
 * Use [-ROW_Num-] when there is information in the row_info_arrays to loop through and need to get the loop count
 * Use [SAR_settings-attr] when areObjectRIA is True
 * 
 * any dynamic class or attributes needed to be added can be done to the <div> info element, STRUCT parser will handle adding it and add it as child of previous element
 */

const staticParts_FC=[
    [// S_0 container for the flip cards
        ['DIV', 'title="HOLDER"'], //just to hold the full code after 
        ['DIV', 'class="activity-instruction"'],
        ['I','class="fas fa-mouse-pointer fa-mouse-pointer"'],
        ['/','I'],
        ['STRONG'],
        ['CREATE_TEXT_NODE',' Press on each card to reveal the answer'],
        ['/','STRONG'],
        ['/','DIV'],
        ['DIV','class="flip-card-game"'],
        ['UL','role="application"', 'aria-labelledby="flip-card-activity"'],
        ['BUILD_INFO_ARRS'],
        ['/','UL'],
        ['/','DIV'],
        ['/','DIV']
    ]
];

const dynamicParts_FC=[
    [// D_0 Code for each Flip Card
        ['LI','class="card-list-item"', 'tabindex="0"', 'role="button"', 'aria-label="Card [-ROW_Num-]"'],
        ['DIV','class="flip-card"'],
        ['DIV','class="card-front"'],
        ['DIV','class="card-question-title"'],
        ['CREATE_TEXT_NODE','[-COL_1-]'],
        ['/','DIV'],
        ['DIV','class="card-content"'],
        ['GET_CONTENT','[-COL_2-]'], //provide a create a div with class of 'not-text' or 'card-text'
        ['/','DIV'],
        ['/','DIV'],
        ['DIV','class="card-back"'],
        ['DIV','class="card-answer-title"'],
        ['CREATE_TEXT_NODE','[-COL_3-]'],
        ['/','DIV'],
        ['DIV','class="card-content"'],
        ['GET_CONTENT','[-COL_4-]'], //provide a create a div with class of 'not-text' or 'card-text'
        ['/','DIV'],
        ['/','DIV'],
        ['/','DIV'],
        ['/','LI']
    ]
];

/**
 * Specify all the classes unique to <component-name> acitivities to pass along to the builder
 * const builder_class_FC:
 *      Find all element node that contains the class "....-Builder" -> will indicate the number of <component-name> builders on the page. Used to loop through each to and used as referenceNode to insertBefore
 * const parentCActivity_class_FC, const parentCActivity_title_FC: 
 *      Find the ancester element node that has class="CustomActivity" title of the <component-name> -> This is parentNode used as as reference to append code to
 * const buildtBody_class_FC:
 *      Find the child element with the class containing "....-Builder-Body" -> this contains all information need to build the <component-name> (headers, content, id etc.). this will be deleted after all content has been used up and built as camera ready html
 * const info_col_def_FC:
 *      Contains all the valid column indexes with content in it, if there is a column in the builder dedicated to ID then include ID as for the first col else is TEXT or MIXED
 * copy and set values for the const below and above the ---
 * -------------
const Custom_Activity_Identifier_FC="";
const parentCActivity_class_FC="CustomActivity"; //default is CustomActivity to identify any advanced interactives, change if something else
const parentCActivity_title_FC="Advance-"+Custom_Activity_Identifier_FC;
const builder_class_FC="Advance-"+Custom_Activity_Identifier_FC+"-Builder";
const buildtBody_class_FC="Advance-"+Custom_Activity_Identifier_FC+"-Builder-Body";
const info_col_def_FC=[];
 * -------------
 */
const Custom_Activity_Identifier_FC="FlipCards";
const parentCActivity_class_FC="CustomActivity"; //default is CustomActivity to identify any advanced interactives, change if something else
const parentCActivity_title_FC="Advance-"+Custom_Activity_Identifier_FC;
const builder_class_FC="Advance-"+Custom_Activity_Identifier_FC+"-Builder";
const buildtBody_class_FC="Advance-"+Custom_Activity_Identifier_FC+"-Builder-Body";
const info_col_def_FC =['TEXT','MIXED','TEXT','MIXED']; //finds the type of information is found in each of the builder columns only. ID will be added anyways as index 0 if not specified as it might not appear as a column for user to add in the builder.

let min_image_width = 180;
